vtkPolyLineWidget Class Reference

widget for vtkPolyLineRepresentation. More...

`#include <vtkPolyLineWidget.h>`

Inheritance diagram for vtkPolyLineWidget:
[legend]
Collaboration diagram for vtkPolyLineWidget:
[legend]

## Public Types

typedef vtkAbstractWidget | Superclass
Public Types inherited from vtkAbstractWidget
typedef vtkInteractorObserver | Superclass
| Standard macros implementing standard VTK methods. More...
Public Types inherited from vtkInteractorObserver
typedef vtkObject | Superclass

## Public Member Functions

virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkPolyLineWidget * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | SetRepresentation (vtkPolyLineRepresentation *r)
| Specify an instance of vtkWidgetRepresentation used to represent this widget in the scene. More...
void | CreateDefaultRepresentation () override
| Create the default widget representation if one is not set. More...
void | SetEnabled (int enabling) override
| Override superclasses' SetEnabled() method because the line widget must enable its internal handle widgets. More...
Public Member Functions inherited from vtkAbstractWidget
vtkAbstractWidget * | NewInstance () const
virtual void | SetProcessEvents (vtkTypeBool)
| Methods to change whether the widget responds to interaction. More...
virtual vtkTypeBool | GetProcessEvents ()
virtual void | ProcessEventsOn ()
virtual void | ProcessEventsOff ()
vtkWidgetEventTranslator * | GetEventTranslator ()
| Get the event translator. More...
void | Render ()
| This method is called by subclasses when a render method is to be invoked on the vtkRenderWindowInteractor. More...
void | SetParent (vtkAbstractWidget *parent)
| Specifying a parent to this widget is used when creating composite widgets. More...
virtual vtkAbstractWidget * | GetParent ()
vtkWidgetRepresentation * | GetRepresentation ()
| Return an instance of vtkWidgetRepresentation used to represent this widget in the scene. More...
virtual void | SetManagesCursor (vtkTypeBool)
| Turn on or off the management of the cursor. More...
virtual vtkTypeBool | GetManagesCursor ()
virtual void | ManagesCursorOn ()
virtual void | ManagesCursorOff ()
void | SetPriority (float) override
| Override the superclass method. More...
Public Member Functions inherited from vtkInteractorObserver
vtkInteractorObserver * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
int | GetEnabled ()
void | EnabledOn ()
void | EnabledOff ()
void | On ()
void | Off ()
virtual void | SetInteractor (vtkRenderWindowInteractor *iren)
| This method is used to associate the widget with the render window interactor. More...
virtual vtkRenderWindowInteractor * | GetInteractor ()
virtual float | GetPriority ()
virtual void | PickingManagedOn ()
| Enable/Disable the use of a manager to process the picking. More...
virtual void | PickingManagedOff ()
virtual void | SetPickingManaged (bool managed)
virtual bool | GetPickingManaged ()
virtual void | SetKeyPressActivation (vtkTypeBool)
| Enable/Disable of the use of a keypress to turn on and off the interactor observer. More...
virtual vtkTypeBool | GetKeyPressActivation ()
virtual void | KeyPressActivationOn ()
virtual void | KeyPressActivationOff ()
virtual void | SetKeyPressActivationValue (char)
| Specify which key press value to use to activate the interactor observer (if key press activation is enabled). More...
virtual char | GetKeyPressActivationValue ()
virtual vtkRenderer * | GetDefaultRenderer ()
| Set/Get the default renderer to use when activating the interactor observer. More...
virtual void | SetDefaultRenderer (vtkRenderer *)
virtual vtkRenderer * | GetCurrentRenderer ()
| Set/Get the current renderer. More...
virtual void | SetCurrentRenderer (vtkRenderer *)
virtual void | OnChar ()
| Sets up the keypress-i event. More...
void | GrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods enable an interactor observer to exclusively grab all events invoked by its associated vtkRenderWindowInteractor. More...
void | ReleaseFocus ()
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
vtkCommand * | GetCommand (unsigned long tag)
void | RemoveObserver (vtkCommand *)
void | RemoveObservers (unsigned long event, vtkCommand *)
void | RemoveObservers (const char *event, vtkCommand *)
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
int | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
int | InvokeEvent (const char *event, void *callData)
int | InvokeEvent (unsigned long event)
int | InvokeEvent (const char *event)
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
void | PrintRevisions (ostream &)
| Legacy. More...

## Static Public Member Functions

static vtkPolyLineWidget * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkPolyLineWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractWidget
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractWidget * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkInteractorObserver
static vtkTypeBool | IsTypeOf (const char *type)
static vtkInteractorObserver * | SafeDownCast (vtkObjectBase *o)
static void | ComputeDisplayToWorld (vtkRenderer *ren, double x, double y, double z, double worldPt[4])
| Convenience methods for outside classes. More...
static void | ComputeWorldToDisplay (vtkRenderer *ren, double x, double y, double z, double displayPt[3])
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (int val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
static void | GlobalWarningDisplayOff ()
static int | GetGlobalWarningDisplay ()
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...

## Protected Types

enum | _WidgetState { Start = 0, Active }

## Protected Member Functions

virtual vtkObjectBase * | NewInstanceInternal () const
| vtkPolyLineWidget ()
| ~vtkPolyLineWidget () override
Protected Member Functions inherited from vtkAbstractWidget
| vtkAbstractWidget ()
| ~vtkAbstractWidget () override
void | SetWidgetRepresentation (vtkWidgetRepresentation *r)
virtual void | SetCursor (int vtkNotUsed(state))
Protected Member Functions inherited from vtkInteractorObserver
| vtkInteractorObserver ()
| ~vtkInteractorObserver () override
virtual void | StartInteraction ()
| Utility routines used to start and end interaction. More...
virtual void | EndInteraction ()
void | ComputeDisplayToWorld (double x, double y, double z, double worldPt[4])
| Helper method for subclasses. More...
void | ComputeWorldToDisplay (double x, double y, double z, double displayPt[3])
virtual void | RegisterPickers ()
| Register internal Pickers in the Picking Manager. More...
void | UnRegisterPickers ()
| Unregister internal pickers from the Picking Manager. More...
vtkPickingManager * | GetPickingManager ()
| Return the picking manager associated on the context on which the observer currently belong. More...
vtkAssemblyPath * | GetAssemblyPath (double X, double Y, double Z, vtkAbstractPropPicker *picker)
| Proceed to a pick, whether through the PickingManager if the picking is managed or directly using the picker, and return the assembly path. More...
int | RequestCursorShape (int requestedShape)
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | CollectRevisions (ostream &)
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Static Protected Member Functions

static void | SelectAction (vtkAbstractWidget *)
static void | EndSelectAction (vtkAbstractWidget *)
static void | TranslateAction (vtkAbstractWidget *)
static void | ScaleAction (vtkAbstractWidget *)
static void | MoveAction (vtkAbstractWidget *)
static void | ProcessKeyEvents (vtkObject *, unsigned long, void *, void *)
Static Protected Member Functions inherited from vtkAbstractWidget
static void | ProcessEventsHandler (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
Static Protected Member Functions inherited from vtkInteractorObserver
static void | ProcessEvents (vtkObject *object, unsigned long event, void *clientdata, void *calldata)
| Handles the char widget activation event. More...

## Protected Attributes

int | WidgetState
vtkCallbackCommand * | KeyEventCallbackCommand
Protected Attributes inherited from vtkAbstractWidget
vtkWidgetRepresentation * | WidgetRep
vtkTypeBool | ManagesCursor
vtkWidgetEventTranslator * | EventTranslator
vtkWidgetCallbackMapper * | CallbackMapper
vtkAbstractWidget * | Parent
void * | CallData
vtkTypeBool | ProcessEvents
Protected Attributes inherited from vtkInteractorObserver
int | Enabled
vtkCallbackCommand * | EventCallbackCommand
vtkCallbackCommand * | KeyPressCallbackCommand
float | Priority
bool | PickingManaged
vtkTypeBool | KeyPressActivation
char | KeyPressActivationValue
vtkRenderWindowInteractor * | Interactor
vtkRenderer * | CurrentRenderer
vtkRenderer * | DefaultRenderer
unsigned long | CharObserverTag
unsigned long | DeleteObserverTag
vtkObserverMediator * | ObserverMediator
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Detailed Description

widget for vtkPolyLineRepresentation.

vtkPolyLineWidget is the vtkAbstractWidget subclass for vtkPolyLineRepresentation which manages the interactions with vtkPolyLineRepresentation. This is based on vtkPolyLineWidget.

This widget allows the creation of a polyline interactively by adding or removing points based on mouse position and a modifier key.

- ctrl+click inserts a new point on the selected line
- shift+click deletes the selected point
- alt+click adds a new point anywhere depending on last selected point. If the first point is selected, the new point is added at the beginning, else it is added at the end.

See also
  vtkPolyLineRepresentation, vtkPolyLineWidget

Events:
  vtkCommand::EndInteractionEvent vtkCommand::InteractionEvent vtkCommand::StartInteractionEvent

Tests:
  vtkPolyLineWidget (Tests)

Definition at line 50 of file vtkPolyLineWidget.h.

## Member Typedef Documentation

## Superclass

typedef vtkAbstractWidget vtkPolyLineWidget::Superclass

Definition at line 54 of file vtkPolyLineWidget.h.

## Member Enumeration Documentation

## _WidgetState

enum vtkPolyLineWidget::_WidgetState

protected

Enumerator
Start |
Active |

Definition at line 84 of file vtkPolyLineWidget.h.

## Constructor & Destructor Documentation

## vtkPolyLineWidget()

vtkPolyLineWidget::vtkPolyLineWidget | ( |  | ) |

protected

## ~vtkPolyLineWidget()

vtkPolyLineWidget::~vtkPolyLineWidget | ( |  | ) |

override protected

## Member Function Documentation

## New()

static vtkPolyLineWidget* vtkPolyLineWidget::New | ( |  | ) |

static

## IsTypeOf()

static vtkTypeBool vtkPolyLineWidget::IsTypeOf | ( | const char * | type | ) |

static

## IsA()

virtual vtkTypeBool vtkPolyLineWidget::IsA | ( | const char * | name | ) |

virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkAbstractWidget.

## SafeDownCast()

static vtkPolyLineWidget* vtkPolyLineWidget::SafeDownCast | ( | vtkObjectBase * | o | ) |

static

## NewInstanceInternal()

virtual vtkObjectBase* vtkPolyLineWidget::NewInstanceInternal | ( |  | ) | const

protected virtual

Reimplemented from vtkAbstractWidget.

## NewInstance()

vtkPolyLineWidget* vtkPolyLineWidget::NewInstance | ( |  | ) | const

## PrintSelf()

void vtkPolyLineWidget::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |

override virtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkAbstractWidget.

## SetRepresentation()

void vtkPolyLineWidget::SetRepresentation | ( | vtkPolyLineRepresentation * | r | ) |

inline

Specify an instance of vtkWidgetRepresentation used to represent this widget in the scene.

Note that the representation is a subclass of vtkProp so it can be added to the renderer independent of the widget.

Definition at line 62 of file vtkPolyLineWidget.h.

## CreateDefaultRepresentation()

void vtkPolyLineWidget::CreateDefaultRepresentation | ( |  | ) |

override virtual

Create the default widget representation if one is not set.

By default, this is an instance of the vtkPolyLineRepresentation class.

Implements vtkAbstractWidget.

## SetEnabled()

void vtkPolyLineWidget::SetEnabled | ( | int | enabling | ) |

override virtual

Override superclasses' SetEnabled() method because the line widget must enable its internal handle widgets.

Reimplemented from vtkAbstractWidget.

## SelectAction()

static void vtkPolyLineWidget::SelectAction | ( | vtkAbstractWidget * |  | ) |

static protected

## EndSelectAction()

static void vtkPolyLineWidget::EndSelectAction | ( | vtkAbstractWidget * |  | ) |

static protected

## TranslateAction()

static void vtkPolyLineWidget::TranslateAction | ( | vtkAbstractWidget * |  | ) |

static protected

## ScaleAction()

static void vtkPolyLineWidget::ScaleAction | ( | vtkAbstractWidget * |  | ) |

static protected

## MoveAction()

static void vtkPolyLineWidget::MoveAction | ( | vtkAbstractWidget * |  | ) |

static protected

## ProcessKeyEvents()

static void vtkPolyLineWidget::ProcessKeyEvents | ( | vtkObject * | ,
|  | unsigned long | ,
|  | void * | ,
|  | void * |
| ) |  |

static protected

## Member Data Documentation

## WidgetState

int vtkPolyLineWidget::WidgetState

protected

Definition at line 83 of file vtkPolyLineWidget.h.

## KeyEventCallbackCommand

vtkCallbackCommand* vtkPolyLineWidget::KeyEventCallbackCommand

protected

Definition at line 97 of file vtkPolyLineWidget.h.

The documentation for this class was generated from the following file:

- Interaction/Widgets/vtkPolyLineWidget.h